--optional use GuiMenue for own Settings (see MultiOverlayV3 Hud moGuiMenue/guiMenueGenerate.lua)

MultiOverlayV3.vehicleSmallApp = {}; --vehicleSmallApp = LuaName, MultiOverlayV3.vehicleSmallApp (MultiOverlayV3. <---needs) (vehicleSmallApp <---your LuaName) set a appSettings without MultiOverlayV3. and lua name your LuaName 

function MultiOverlayV3.vehicleSmallApp:loadApp(self, isServer) --loadApp() <--needs for MultiOverlayV3
	if isServer then return;end;
	local version = 0.1; --before edit,check is MultiOverlayV3 Hud Mod App Version UpToDate or not (Check TestApp at MultiOverlayV3 Zip)
	print("---loading VehicleSmall App (".. tostring(version).. ") for ".. tostring(MultiOverlayV3.metadata.title))		
	MultiOverlayV3.vehicleSmallApp.mapIsLoad = false; --optional own function or ...
	if version >= MultiOverlayV3.metadata.clientAppVersion then				
		MultiOverlayV3.vehicleSmallApp.lastJoin = {attachedLimit=5,vehicle=1,tractorOnly=1,harvester=1,car=1,otherVehicle=1,tractorTrailer=1,parking=1,saveVehicle=1};
		local myCmdTable, errorTable = 0, {};
		--default values--
		local newCmdTable = {	
			realName = "VehicleSmall App"; --needs(string), for heading/Titel/Info etc.
			guiMenue = false; --needs(boolean), is install or not a GuiMenue for your App
			--guiMenueTable = 0; --needs(int), is ...guiMenue=true, optional is install or not a GuiMenue for you App set later your modGuiMenueTable (check MultiOverlayV3.moGuiMenue.guiMenueGenerate)
			--guiMenueName = "VehicleSmall App"; --needs(string), is ...guiMenue=true and ...guiMenueTable=..., optional is install or not a GuiMenue for you App set later your modGuiMenueTable
			onOff = true; --optional(boolean) for uninstall/install/disable/enable or not, default nil(false) ! Attention ! Your Mod Edit LS Values ? --> set value boolean not true
			luaName = "vehicleSmallApp"; --needs(string *your lua name*), for cmd action(is cmd action string) and classification in Save/XML --> ! should be unique !	
			cmdTable = {};	--needs(table) for your cmd`s
		};
		--default values--		
		--cmd 1--
		newCmdTable.cmdTable[1] = {
			cmdName = "vehicleJoin"; --needs(string) for cmd identification -->classification in Save/XML --> ! should be unique !
			displayName = "Fahrzeugliste Vorwärt/Zurück Springen"; 	--optional(string) for player help in MultiOverlayV3 Gui Menue Settings	
			--iconSuggestion = "vehicleSmallAppIcon1_"; --optional(string, your icon) for color rotation or etc. ! Attention ! MultiOverlayV3 set automatic _ for better identification
			--iconSuggestionTxt = "Color/Rotate Icon"; --optional(string) help text for player is iconSuggestion
			multiple = true; --needs(boolean), is your cmd multiple with other cmd`s	
			sortBy = "VehicleSmall App";
			infoTxt = "Damit springst du zum nächsten Fahrzeug vor/zurück\nSet Left and Right Click\nTip set vehicleSmallAppIcon5_"; --optional(string), is small info text for player and List(MultiOverlayV3 Gui Menue)
			helpTxt = "Fahrzeug vor/zurück"; --optional(string), is extra help text for Gui Menue MultiOverlayV3 List
			click = {mouseButtonLeft=true, mouseButtonMiddle=false, mouseButtonRight=true, key=false}; --needs(table) left/middle/right MouseClick/keyClick
			typ = "action"; --needs(string), for info/sort cmd and execute (see list in moTables.lua)  -->action is best,Moh only performs action and end
			--bsp a function
			action = MultiOverlayV3.vehicleSmallApp.vehicleJoin; --needs(string or function) -->is string then needs MultiOverlayV3.yourLuaName.yourString(...) Bsp: MultiOverlayV3.vehicleSmallApp.vehicleJoinForward(...)
			--bsp a function
			ownValues = {};	--optional(string table etc.), for your later or.... (with your myCmdTable position access, also with MultiOverlayV3.cmdTable[yourCmdTable].cmd[1].ownValue) 
		};
		--cmd 1--
		--cmd 2--
		newCmdTable.cmdTable[2] = {
			cmdName = "tractorJoin";
			displayName = "Tractor Vor/Zurück Springen";			
			multiple = true;
			sortBy = "VehicleSmall App";
			infoTxt = "Damit springst du zum nächsten Tractor(Type) vor/zurück\nSet Left and Right Click\nTip set vehicleSmallAppIcon1_";
			helpTxt = "Fahrzeugliste zurück";
			click = {mouseButtonLeft=true, mouseButtonMiddle=false, mouseButtonRight=true, key=false}; --left/middle/right MouseClick
			typ = "action";
			--bsp a string
			action = "vehicleJoinType"; 
			--bsp a string
			ownValues = {typ="tractorOnly"};			 
		};
		--cmd 2--
		
		--cmd 3--
		newCmdTable.cmdTable[3] = {
			cmdName = "harvesterJoin";
			displayName = "Harvester Vor/Zurück Springen";			
			multiple = true;
			sortBy = "VehicleSmall App";
			infoTxt = "Damit springst du zum nächsten Drescher(Type) vor/zurück\nSet Left and Right Click\nTip set vehicleSmallAppIcon2_";
			helpTxt = "Harvesterliste vor/zurück";
			click = {mouseButtonLeft=true, mouseButtonMiddle=false, mouseButtonRight=true, key=false}; --left/middle/right MouseClick
			typ = "action";
			--bsp a string
			action = "vehicleJoinType"; 
			--bsp a string
			ownValues = {typ="harvester"};			 
		};
		--cmd 3--		
		--cmd 4--
		newCmdTable.cmdTable[4] = {
			cmdName = "carJoin";
			displayName = "Car Vor/Zurück Springen";			
			multiple = true;
			sortBy = "VehicleSmall App";
			infoTxt = "Damit springst du zum nächsten Auto(Type) vor/zurück\nSet Left and Right Click\nTip set vehicleSmallAppIcon3_";
			helpTxt = "Carliste vor/zurück";
			click = {mouseButtonLeft=true, mouseButtonMiddle=false, mouseButtonRight=true, key=false}; --left/middle/right MouseClick
			typ = "action";
			--bsp a string
			action = "vehicleJoinType"; 
			--bsp a string
			ownValues = {typ="car"};			 
		};
		--cmd 4--
		--cmd 5--
		newCmdTable.cmdTable[5] = {
			cmdName = "tractorTrailerFillJoin";
			displayName = "Tractor/TrailerFill Vor/Zurücks Springen";			
			multiple = true;
			sortBy = "VehicleSmall App";
			infoTxt = "Damit springst du zum nächsten Tractor/TrailerFill(Type) vor/zurück\nSet Left and Right Click\nTip set vehicleSmallAppIcon4_";
			helpTxt = "Tractor with TrailerFillliste vor/zurück";
			click = {mouseButtonLeft=true, mouseButtonMiddle=false, mouseButtonRight=true, key=false}; --left/middle/right MouseClick
			typ = "action";
			--bsp a string
			action = "vehicleJoinType"; 
			--bsp a string
			ownValues = {typ="tractorTrailerFill"};			 
		};
		--cmd 5--
		--cmd 6--
		newCmdTable.cmdTable[6] = {
			cmdName = "tractorTrailerNormalJoin";
			displayName = "Tractor/TrailerNormal Vor/Zurücks Springen";			
			multiple = true;
			sortBy = "VehicleSmall App";
			infoTxt = "Damit springst du zum nächsten Tractor/TrailerNormal(Type) vor/zurück\nSet Left and Right Click\nTip set vehicleSmallAppIcon9_";
			helpTxt = "Tractor with TrailerNormalliste vor/zurück";
			click = {mouseButtonLeft=true, mouseButtonMiddle=false, mouseButtonRight=true, key=false}; --left/middle/right MouseClick
			typ = "action";
			--bsp a string
			action = "vehicleJoinType"; 
			--bsp a string
			ownValues = {typ="tractorTrailerNormal"};			 
		};
		--cmd 6--
		--cmd 7--
		newCmdTable.cmdTable[7] = {
			cmdName = "truckJoin";
			displayName = "Truck Vor/Zurücks Springen";			
			multiple = true;
			sortBy = "VehicleSmall App";
			infoTxt = "Damit springst du zum nächsten Truck(Type) vor/zurück\nSet Left and Right Click\nTip set vehicleSmallAppIcon10_";
			helpTxt = "Truckliste vor/zurück";
			click = {mouseButtonLeft=true, mouseButtonMiddle=false, mouseButtonRight=true, key=false}; --left/middle/right MouseClick
			typ = "action";
			--bsp a string
			action = "vehicleJoinType"; 
			--bsp a string
			ownValues = {typ="truck"};			 
		};
		--cmd 7--
		--cmd 8--
		newCmdTable.cmdTable[8] = {
			cmdName = "otherVehicleJoin";
			displayName = "Tele/Radl./Oder Vor/Zurücks Springen";			
			multiple = true;
			sortBy = "VehicleSmall App";
			infoTxt = "Damit springst du zum nächsten OtherVehicle(Type) vor/zurück\nSet Left and Right Click\nTip set vehicleSmallAppIcon11_";
			helpTxt = "Otherliste vor/zurück";
			click = {mouseButtonLeft=true, mouseButtonMiddle=false, mouseButtonRight=true, key=false}; --left/middle/right MouseClick
			typ = "action";
			--bsp a string
			action = "vehicleJoinType"; 
			--bsp a string
			ownValues = {typ="otherVehicle"};			 
		};
		--cmd 8--
		if test then
		--cmd 8--
		newCmdTable.cmdTable[8] = {
			cmdName = "updownAttached";
			displayName = "All Attached Up/Down";			
			multiple = true;
			sortBy = "VehicleSmall App";
			infoTxt = "Alles Senken/Heben\nTip set vehicleSmallAppIcon10_";
			helpTxt = "All Attached Up/Down";
			click = {mouseButtonLeft=true, mouseButtonMiddle=false, mouseButtonRight=true, key=false}; --left/middle/right MouseClick
			typ = "action";
			--bsp a string
			action = "vehicleAttachedUpDown"; 
			--bsp a string
			ownValues = {};			 
		};
		--cmd 8--
		--cmd 9--
		newCmdTable.cmdTable[9] = {
			cmdName = "foldAttached";
			displayName = "All Attached Fold";			
			multiple = true;
			sortBy = "VehicleSmall App";
			infoTxt = "Alles ausklappen\nTip set vehicleSmallAppIcon10_";
			helpTxt = "All Attached Fold";
			click = {mouseButtonLeft=true, mouseButtonMiddle=false, mouseButtonRight=true, key=false}; --left/middle/right MouseClick
			typ = "action";
			--bsp a string
			action = "vehicleAttachedFold"; 
			--bsp a string
			ownValues = {};			 
		};
		--cmd 10--
		newCmdTable.cmdTable[10] = {
			cmdName = "onOffAttached";
			displayName = "All Attached On/Off";			
			multiple = true;
			sortBy = "VehicleSmall App";
			infoTxt = "Alles anschalten\nTip set vehicleSmallAppIcon10_";
			helpTxt = "All Attached On/Off";
			click = {mouseButtonLeft=true, mouseButtonMiddle=false, mouseButtonRight=true, key=false}; --left/middle/right MouseClick
			typ = "action";
			--bsp a string
			action = "vehicleAttachedOnOff"; 
			--bsp a string
			ownValues = {};			 
		};
		--cmd 10--
		end;
		--cmd --
		--newCmdTable.cmdTable[] = {
		--	cmdName = "parkingJoin";
		--	displayName = "Geparkte Fahrzeuge Vorwärts/Rückwärts Springen";			
		--	multiple = true;
		--	sortBy = "VehicleSmall App";
		--	infoTxt = "Damit springst du zum nächsten geparkten Fahrzeug vor/zurück\nSet Left and Right Click(Parking Mod)\nTip set vehicleSmallAppIcon7_";
		--	helpTxt = "Parkingliste vor/zurück";
		--	click = {mouseButtonLeft=true, mouseButtonMiddle=false, mouseButtonRight=true, key=false}; --left/middle/right MouseClick
		--	typ = "action";
			--bsp a string
		--	action = "vehicleJoinType"; 
			--bsp a string
		--	ownValues = {typ="parking"};			 
		--};
		--cmd --
		--cmd --
		--newCmdTable.cmdTable[] = {
		--	cmdName = "saveVehicleJoin";
		--	displayName = "Gespeicherte Fahrzeuge Vorwärts/Rückwärts Springen";			
		--	multiple = true;
		--	sortBy = "VehicleSmall App";
		--	infoTxt = "Damit springst du zum nächsten gespeicherten Fahrzeug vor/zurück\nSet Left and Right Click\nTip set vehicleSmallAppIcon8_";
		--	helpTxt = "Save Vehicleliste vor/zurück";
		--	click = {mouseButtonLeft=true, mouseButtonMiddle=false, mouseButtonRight=true, key=false}; --left/middle/right MouseClick
		--	typ = "action";
			--bsp a string
		--	action = "vehicleJoinType"; 
			--bsp a string
		--	ownValues = {typ="saveVehicle"};			 
		--};
		--cmd --
		
		myCmdTable, errorTable = moSetGetCmd:generateNewCmd(newCmdTable);		
		--for test set true or set own function etc.
		local errorPrint = false;
		if errorPrint and #errorTable > 0 then
			for a=1, #errorTable do
				print("! ERROR ! VehicleSmall App -->cmd generate error ".. tostring(a).. ": ".. tostring(errorTable[a]))
			end;
		end;			
		
		
		local overlayDir = "app/vehicleSmallApp/"; --app Directory = app Lua Name  ...modsSettings/MultioverlayV3/app/vehicleSmallApp/vehicleSmallApp.dds
		--optional load Image Datei (dds format) --> fileName, imageFormat(m64x64,m128x128,m256x256,m128x256,m128x512), iconName, firstIcon, lastIcon load, infoTxt(optional) --Icon Dimensions 32x32 at image--
		--moh return beginTable and endTable Integer (moSetGetOverlays.previewAppIcons[beginTable] is your first icon a table, optional for args outPut input or splitDisplay Overlays or renderText over Icons etc.)
		local  beginIcon, endIcon = moSetGetOverlays:loadPreviewAppIconsOverlays(self, overlayDir.. "vehicleSmallApp.dds", "m256x256", "vehicleSmallAppIcon", 1, 1, 11, "VehicleSmall App Icon", true); --App Icons for Moh PDAs
		--print("begin Icon = ".. tostring(beginIcon).. " , endIcon = ".. tostring(endIcon))
		--! Attention !! set Icon Name not with _ -MultiOverlayV3 set automatic _ at the end from your icon name
		MultiOverlayV3.vehicleSmallApp.joinSaveVehicle = {};
		MultiOverlayV3.vehicleSmallApp.clickAreas = {};MultiOverlayV3.vehicleSmallApp.clickAreas["garage"] = {};		
		MultiOverlayV3.vehicleSmallApp.pdaGarageOn = false;		
		MultiOverlayV3.vehicleSmallApp.pdaGarageDragDropOn = false;
		MultiOverlayV3.vehicleSmallApp.pdaGarage = {};		---------(self, appDesignIconTable, loadArtDesign, zoomDefault, distanceIcons, reset)
		local isLoad = moSetGetOverlays:loadDesignGroundOverlaysForApp(self, MultiOverlayV3.vehicleSmallApp.pdaGarage, 1, 5, 1); --load Design Ground for a App (own use) or for moDraw.simpleAppPDA:setOpenDraw(self, appName, appPdaIcons, posX, posY, maxWidth, maxHeight, distanceAppIcons, setOtherButtonTable) --return posX + posX+width and posY + posY+height Area
		if not isLoad or #MultiOverlayV3.vehicleSmallApp.pdaGarage < 1 then --check first is ready or not
			print("!! INFO !! VehicleSmall App not Load Design Ground Icons")
			MultiOverlayV3.vehicleSmallApp.pdaGarage = nil;
		else
			MultiOverlayV3.vehicleSmallApp.pdaGarage.viewOtherValues.dragDropOn = true;
		end;		
	else
		print("-ERROR- ".. tostring(MultiOverlayV3.metadata.title).. " vehicleSmallApp (".. tostring(version).. ") not compatible with MultiOverlayV3".. tostring(MultiOverlayV3.metadata.version))
		print("-INFO- Download new VehicleSmall APP Version at ModHoster.de -INFO-")
	end;	
end;

function MultiOverlayV3.vehicleSmallApp:vehicleIcons(self)
	local playerFarmId = g_currentMission.player.farmId;
	local isError = false;
	if g_currentMission.vehicles ~= nil and #g_currentMission.vehicles > 0 then
		local vehiclesLength = Utils.getNoNil(#g_currentMission.vehicles, 0);
		local vehicleList = {};
		if vehiclesLength > 0 then 
			MultiOverlayV3.vehicleSmallApp.vehicleStoreItems = {};
			local lastControlled = 1;
			local lastAttached = 1;
			for a=1, vehiclesLength do
				local vehicle = g_currentMission.vehicles[a];
				if vehicle.configFileName == nil and vehicle.xmlFile == nil and not isError then isError = true;print("!! ERROR !! Download (VehicleIcons) over VehicleSmall APP ");return;end;
				if vehicle.ownerFarmId == playerFarmId then --and vehicle.getIsControlled ~= nil then					
					local xmlVehicle = Utils.getNoNil(vehicle.configFileName, vehicle.xmlFile);	
					
					local storeItem = g_storeManager:getItemByXMLFilename(xmlVehicle:lower()); --new LS19 !!!					
					--local storeItem = StoreItemUtil.storeItemsByXMLFilename[xmlVehicle]; --LS17
					--local storeItem = g_storeManager.xmlFilenameToItem[string.lower(xmlVehicle)] --other option
					if storeItem ~= nil and xmlVehicle ~= nil and storeItem.imageFilename ~= "data/store/store_empty.png" and not string.find(storeItem.imageFilename, "data/store/store_pallet") then
						--if a < 10 then
							--for key, value in pairs(storeItem) do
							--	print("StoreItem key und value ...".. tostring(key).. "-----".. tostring(value))
							--end;
						--end;
						local modTxt = "_noMod";
						if storeItem.isMod then modTxt = "_isMod";end;
						local fullName = vehicle:getFullName();
						--print("fullName= ".. tostring(fullName))
						--print("typeName= ".. tostring(vehicle.typeName)) --local typeName = Utils.getNoNil(string.lower(vehicle.typeName), "Unknown");
						--print("vsAppName= ".. tostring(vehicle.vsAppName))
						--print("CategoryName= ".. tostring(storeItem.categoryName))
						if vehicleList[fullName.. modTxt] == nil then vehicleList[fullName.. modTxt] = {}; 
							local zoomLevel = 5;							
							function insertVehicle(tablePos, controlled)								
								MultiOverlayV3.vehicleSmallApp.vehicleStoreItems[tablePos].overlay = Overlay:new(storeItem.imageFilename, 0, 0, moSetGetOverlays.buttonGfxWidth1*moSetGetOverlays.defaultZoomOutInTemp*zoomLevel, moSetGetOverlays.buttonGfxHeight1*moSetGetOverlays.defaultZoomOutInTemp*zoomLevel);
								MultiOverlayV3.vehicleSmallApp.vehicleStoreItems[tablePos].width = moSetGetOverlays.buttonGfxWidth1*moSetGetOverlays.defaultZoomOutInTemp*zoomLevel;
								MultiOverlayV3.vehicleSmallApp.vehicleStoreItems[tablePos].height = moSetGetOverlays.buttonGfxHeight1*moSetGetOverlays.defaultZoomOutInTemp*zoomLevel;
								MultiOverlayV3.vehicleSmallApp.vehicleStoreItems[tablePos].vehicleStoreValues = storeItem;
								MultiOverlayV3.vehicleSmallApp.vehicleStoreItems[tablePos].vehicleFullName = fullName;
								MultiOverlayV3.vehicleSmallApp.vehicleStoreItems[tablePos].hasVehicles = 1;
								MultiOverlayV3.vehicleSmallApp.vehicleStoreItems[tablePos].isMod = storeItem.isMod;
								MultiOverlayV3.vehicleSmallApp.vehicleStoreItems[tablePos].controlled = controlled;
								MultiOverlayV3.vehicleSmallApp.vehicleStoreItems[tablePos].isWeight = storeItem.categoryName == "WEIGHTS";
								if MultiOverlayV3.vehicleSmallApp.vehicleStoreItems[tablePos].isWeight then
									MultiOverlayV3.vehicleSmallApp.vehicleStoreItems[tablePos].weight = vehicle:getTotalMass()*1000;
								end;
							end;
							if vehicle.getIsControlled ~= nil and vehicle:getIsEnterable() then 
								table.insert(MultiOverlayV3.vehicleSmallApp.vehicleStoreItems, 1, {});
								insertVehicle(1, true);
								lastControlled = lastControlled+1;								
							else
								if vehicle.spec_attacherJoints ~= nil and storeItem.categoryName ~= "WEIGHTS" then
									table.insert(MultiOverlayV3.vehicleSmallApp.vehicleStoreItems, lastControlled, {});
									insertVehicle(lastControlled, false);
									lastAttached = lastControlled;									
								elseif storeItem.categoryName == "WEIGHTS" then
									if lastAttached > 1 then
										table.insert(MultiOverlayV3.vehicleSmallApp.vehicleStoreItems, lastControlled+lastAttached, {});
										insertVehicle(lastControlled+lastAttached, false);
									else
										table.insert(MultiOverlayV3.vehicleSmallApp.vehicleStoreItems, lastControlled, {});
										insertVehicle(lastControlled, false);
									end;									
								else
									MultiOverlayV3.vehicleSmallApp.vehicleStoreItems[#MultiOverlayV3.vehicleSmallApp.vehicleStoreItems+1] = {};
									insertVehicle(#MultiOverlayV3.vehicleSmallApp.vehicleStoreItems, false);									
								end;
							end;						
						else
							for a=1, #MultiOverlayV3.vehicleSmallApp.vehicleStoreItems do
								if MultiOverlayV3.vehicleSmallApp.vehicleStoreItems[a] ~= nil and MultiOverlayV3.vehicleSmallApp.vehicleStoreItems[a].vehicleFullName == fullName then
									MultiOverlayV3.vehicleSmallApp.vehicleStoreItems[a].hasVehicles = MultiOverlayV3.vehicleSmallApp.vehicleStoreItems[a].hasVehicles+1;
								end;
							end;
						end;
					elseif not isError then
						isError = true;
						print("!! ERROR !! Download (VehicleIcons StoreItems not found) over VehicleSmall APP ")
					end;
				end;
			end;			
		end;		
	elseif not isError then
		isError = true;
		print("!! ERROR !! g_currentMission.vehicles not found or 0 ")
	end;
end;

function MultiOverlayV3.vehicleSmallApp.vehicleJoinType(...)
	if ... ~= nil then		
		local args = {...};		
		if args ~= nil and args[1] ~= nil and args[2] ~= nil and args[3] ~= nil and args[4] ~= nil and args[5] ~= nil then			
			local joinType = Utils.getNoNil(args[5].ownValues.typ, nil);			
			if joinType ~= nil then
				if joinType == "tractorOnly" then
					if args[1] == "mouseButtonRight" then MultiOverlayV3.vehicleSmallApp.toggleVehicle(-1, "tractor");elseif args[1] == "mouseButtonLeft" then MultiOverlayV3.vehicleSmallApp.toggleVehicle(1, "tractor");end;
				elseif joinType == "truck" then
					if args[1] == "mouseButtonRight" then MultiOverlayV3.vehicleSmallApp.toggleVehicle(-1, "truck");elseif args[1] == "mouseButtonLeft" then MultiOverlayV3.vehicleSmallApp.toggleVehicle(1, "truck");end;
				elseif joinType == "harvester" then
					if args[1] == "mouseButtonRight" then MultiOverlayV3.vehicleSmallApp.toggleVehicle(-1, "harvester");elseif args[1] == "mouseButtonLeft" then MultiOverlayV3.vehicleSmallApp.toggleVehicle(1, "harvester");end;
				elseif joinType == "car" then
					if args[1] == "mouseButtonRight" then MultiOverlayV3.vehicleSmallApp.toggleVehicle(-1, "car");elseif args[1] == "mouseButtonLeft" then MultiOverlayV3.vehicleSmallApp.toggleVehicle(1, "car");end;
				elseif joinType == "otherVehicle" then
					if args[1] == "mouseButtonRight" then MultiOverlayV3.vehicleSmallApp.toggleVehicle(-1, "othervehicle");elseif args[1] == "mouseButtonLeft" then MultiOverlayV3.vehicleSmallApp.toggleVehicle(1, "othervehicle");end;
				elseif joinType == "tractorTrailerFill" then
					if args[1] == "mouseButtonRight" then MultiOverlayV3.vehicleSmallApp.toggleVehicle(-1, "tractor,truck,car,otherVehicle", true, "trailerfill");elseif args[1] == "mouseButtonLeft" then MultiOverlayV3.vehicleSmallApp.toggleVehicle(1, "tractor,truck,car,othervehicle", true, "trailerfill");end;
				elseif joinType == "tractorTrailerNormal" then
					if args[1] == "mouseButtonRight" then MultiOverlayV3.vehicleSmallApp.toggleVehicle(-1, "tractor,truck,car,othervehicle", true, "trailernormal");elseif args[1] == "mouseButtonLeft" then MultiOverlayV3.vehicleSmallApp.toggleVehicle(1, "tractor,truck,car,othervehicle", true, "trailernormal");end;
				end;			
			end;
		end;
	end;
end;

--VehicleInspector insp.
function MultiOverlayV3.vehicleSmallApp:getAttachedTrailer(vehicle, attachedLimit, trailerType, foundFillTrailer)	
	local attached = 0;
	local attachedTrailer = 0;	
	local foundFillTrailer = foundFillTrailer;
	if vehicle.getAttachedImplements ~= nil then 
		local attachTable = vehicle.getAttachedImplements(vehicle);
		if attachTable ~= nil and attachedLimit <= MultiOverlayV3.vehicleSmallApp.lastJoin.attachedLimit then		
			for _,attach in pairs(attachTable) do		
				if attach.object ~= nil and attach.object.typeName ~= nil then
					local typeName = Utils.getNoNil(string.lower(attach.object.typeName), "Unknown");
					if not string.find(typeName, "implements") and not string.find(typeName, "Unknown") then
						attached = attached+1;
					end;					
					local typeCategory = nil;
					if attach.object.vsAppName ~= nil then typeCategory = Utils.getNoNil(string.lower(attach.object.vsAppName), "unknown");end;					
					
					if typeCategory ~= nil and trailerType ~= nil then
						if typeCategory == "trailerfill" then foundFillTrailer = true;end;
						if typeCategory == "trailerfill" and trailerType == "trailerfill" then						
							attachedTrailer = attachedTrailer+1;
						end;
						if typeCategory == "trailernormal" and trailerType == "trailernormal" then
							attachedTrailer = attachedTrailer+1;
						end;						
					end;					
					local tempAttached, tempAttachedTrailer, tempFoundFillTrailer = MultiOverlayV3.vehicleSmallApp:getAttachedTrailer(attach.object, attachedLimit+1, trailerType, foundFillTrailer);
					attached = attached+tempAttached;
					attachedTrailer = attachedTrailer+tempAttachedTrailer;
					if not foundFillTrailer and tempFoundFillTrailer then foundFillTrailer = tempFoundFillTrailer;end;
				end;
			end;
		end;
	end;
	return attached, attachedTrailer, foundFillTrailer;
end;

function MultiOverlayV3.vehicleSmallApp.toggleVehicle(delta, vehicleType, trailer, trailerType)
	local searchVehicleType = vehicleType or "";
	--local tractorOnly = "tractor";
	--local harvester = "harvester,combinedrivable,combinecutterfruitpreparer,loadervehicle";
	--local tractorTrailer = "";
	--local car = "car_";
	--local categoryNameHarvester = "potatovehicles, beetvehicles, harvesters"
	--local categoryNameTractor = "tractor"
	function isVehicleType(vehicle)
		if searchVehicleType == nil or string.len(searchVehicleType) == 0 then return true;end;
		local typeCategory = Utils.getNoNil(string.lower(vehicle.vsAppName), "unknown");
		if typeCategory == nil or typeCategory == "unknown" then return false;end;
		if string.find(searchVehicleType, typeCategory) or string.find(typeCategory, searchVehicleType) then return true;end;
		return false;
	end;
	function isVehicleTrailer(vehicle)
		if trailer == nil then return true;end;
		if vehicle.getAttachedImplements ~= nil then 
			local attach, attachedTrailer, foundFillTrailer = MultiOverlayV3.vehicleSmallApp:getAttachedTrailer(vehicle, 1, trailerType, false);
			if attachedTrailer > 0 and trailer ~= nil and trailer and trailerType == "trailernormal" and foundFillTrailer then return false;end;
			if attachedTrailer > 0 then return true;end;
			--if trailerType ~= nil and trailerType == "trailernormal" and attach > 0 then return true;end;
		end;
		return false;
	end;
	if not g_currentMission.isToggleVehicleAllowed then
		return;
	end;	
	local numVehicles = table.getn(g_currentMission.enterables);
	if numVehicles > 0 then
		local index = 1;
		local oldIndex = 1;
		if not g_currentMission.controlPlayer and g_currentMission.controlledVehicle ~= nil then
			for i = 1, numVehicles do
				if g_currentMission.controlledVehicle == g_currentMission.enterables[i] and isVehicleType(g_currentMission.enterables[i]) and isVehicleTrailer(g_currentMission.enterables[i]) and not MultiOverlayV3.vehicleSmallApp.parkingVehicle(g_currentMission.enterables[i]) then
					oldIndex = i;
					index = i + delta;

					if numVehicles < index then
						index = 1;
					end;

					if index < 1 then
						index = numVehicles;
					end;
					break;
				end;
			end;
		elseif delta < 0 then
			index = numVehicles;
		end;
		local found = false;
		repeat
			local enterable = g_currentMission.enterables[index];
			if enterable:getIsTabbable() and enterable:getIsEnterable() and isVehicleType(enterable) and isVehicleTrailer(enterable) and not MultiOverlayV3.vehicleSmallApp.parkingVehicle(enterable) then
				found = true;
			else
				index = index + delta;
				if numVehicles < index then
					index = 1;
				end;
				if index < 1 then
					index = numVehicles;
				end;
			end;
		until found or index == oldIndex;
		if found then
			g_currentMission:requestToEnterVehicle(g_currentMission.enterables[index]);
		end;
	end;
end;

function MultiOverlayV3.vehicleSmallApp.vehicleJoin(...) --old
	if ... ~= nil then		
		local args = {...};		
		if args ~= nil and args[1] ~= nil and args[2] ~= nil and args[3] ~= nil and args[4] ~= nil then					
			if args[1] == "mouseButtonRight" then MultiOverlayV3.vehicleSmallApp.toggleVehicle(-1, "");elseif args[1] == "mouseButtonLeft" then MultiOverlayV3.vehicleSmallApp.toggleVehicle(1, "");end;
			--if args[1] == "mouseButtonRight" then MultiOverlayV3.vehicleSmallApp.vehicleJoinBack();elseif args[1] == "mouseButtonLeft" then MultiOverlayV3.vehicleSmallApp.vehicleJoinForward();end;
		end;
	end;
end;

function MultiOverlayV3.vehicleSmallApp.parkingVehicle(vehicle) --parkingMod
	if vehicle.spec_parkvehicle ~= nil then
		local spec = vehicle.spec_parkvehicle;
		if spec.state[spec.uniqueUserId] then return true;end;
		return false;
	end;
	return false;
end;

function MultiOverlayV3.vehicleSmallApp.vehicleAttachedOnOff(...)
	if ... ~= nil then		
		local args = {...};	
		if args[1] ~= nil and g_currentMission.controlledVehicle ~= nil then
			local onOff = args[1] == "mouseButtonLeft";
			local vehicle = g_currentMission.controlledVehicle;									
			function onoff(vehicleObject)
				if vehicleObject.setIsTurnedOn ~= nil then
					vehicleObject:setIsTurnedOn(onOff, vehicle);									
				end;
			end;
			if vehicle.getAttachedImplements ~= nil then
				MultiOverlayV3.vehicleSmallApp:setAttached(vehicle, 1, onOff, false, false, true);
			else --hard Attached								
				onoff(vehicle) --an/aus	
			end;
		end;
	end;
end;

function MultiOverlayV3.vehicleSmallApp.vehicleAttachedFold(...)
	if ... ~= nil then		
		local args = {...};	
		if args[1] ~= nil and g_currentMission.controlledVehicle ~= nil then
			local onOff = args[1] == "mouseButtonLeft";
			local vehicle = g_currentMission.controlledVehicle;
			function foldstate(vehicleObject)
				if vehicleObject.setFoldState ~= nil then
					--local spec = vehicleObject.spec_foldable;
					--vehicleObject:setFoldState(spec.turnOnFoldDirection, onOff, true);
					local direction = -1;if not onOff then direction = 1;end;
					vehicleObject:setFoldState(direction, onOff, true);									
				end;
			end;						
			if vehicle.getAttachedImplements ~= nil then
				MultiOverlayV3.vehicleSmallApp:setAttached(vehicle, 1, onOff, true, false, false);
			else --hard Attached
				foldstate(vehicle) --auf/zu klappen				
			end;
		end;
	end;
end;

function MultiOverlayV3.vehicleSmallApp.vehicleAttachedUpDown(...)
	if ... ~= nil then		
		local args = {...};	
		if args[1] ~= nil and g_currentMission.controlledVehicle ~= nil then
			local onOff = args[1] == "mouseButtonLeft";
			local vehicle = g_currentMission.controlledVehicle;
			function updown(vehicleObject)				
				if vehicleObject.setLoweredAll ~= nil then
					vehicleObject:setLoweredAll(onOff, vehicle);									
				end;
				if vehicleObject.setLowered ~= nil then
					vehicleObject:setLowered(onOff, vehicle);									
				end;
				vehicle:activate();
			end;					
			if vehicle.getAttachedImplements ~= nil then
				MultiOverlayV3.vehicleSmallApp:setAttached(vehicle, 1, onOff, false, true, false);
			else --hard Attached				
				updown(vehicle) --hoch/runter
			end;
		end;
	end;
end;

function MultiOverlayV3.vehicleSmallApp:setAttached(vehicle, attachedLimit, onOff, setFold, setUpDown, setOnOff)
	function updown(vehicleObject)		
		if vehicleObject.setLoweredAll ~= nil then
			vehicleObject:setLoweredAll(onOff, vehicle);									
		end;
		if vehicleObject.setLowered ~= nil then
			vehicleObject:setLowered(onOff, vehicle);									
		end;
		local spec = vehicle.spec_combine;
		if spec ~= nil and spec.numAttachedCutters > 0 then
			local allowLowering = not vehicle:getIsAIActive() or not vehicle:getRootVehicle():getAIIsTurning();
			for _, cutter in pairs(spec.attachedCutters) do
				if allowLowering and cutter ~= self then
					local jointDescIndex = vehicle:getAttacherJointIndexFromObject(cutter);

					vehicle:setJointMoveDown(jointDescIndex, onOff, true);
				end;
			end;		
		end;		
	end;
	function foldstate(vehicleObject)
		if vehicleObject.setFoldState ~= nil then
			local spec = vehicleObject.spec_foldable;
			print("turnOnFoldDirection= ".. tostring(spec.turnOnFoldDirection))
			--vehicleObject:setFoldState(spec.turnOnFoldDirection, onOff, true);
			local direction = -1;if not onOff then direction = 1;end;
			vehicleObject:setFoldState(direction, onOff, true);									
		end;
	end;
	function onoff(vehicleObject)
		if vehicleObject.setIsTurnedOn ~= nil then
			vehicleObject:setIsTurnedOn(onOff, vehicle);									
		end;
	end;			
	if vehicle.getAttachedImplements ~= nil then
		local attachTable = vehicle.getAttachedImplements(vehicle);
		if attachTable ~= nil and attachedLimit <= MultiOverlayV3.vehicleSmallApp.lastJoin.attachedLimit then	
			for index,attach in pairs(attachTable) do		
				if attach.object ~= nil and attach.object.typeName ~= nil then
					local typeName = Utils.getNoNil(string.lower(attach.object.typeName), "Unknown");
					if not string.find(typeName, "implements") and not string.find(typeName, "Unknown") then						
						if setFold then foldstate(attach.object);end; --auf/zu klappen
						if setUpDown then updown(attach.object);end; --hoch/runter						
						if setOnOff then onoff(attach.object);end; --an/aus	
						MultiOverlayV3.vehicleSmallApp:setAttached(attach.object, attachedLimit+1, onOff, setFold, setUpDown, setOnOff);
					else
						attachedLimit = attachedLimit+1;
					end;
				end;
			end;
		end;	
	end;	
end;

--optional--
local vehicleIconTest = false;
function MultiOverlayV3.vehicleSmallApp:deleteMap(self)
	if MultiOverlayV3:getServer() then return;end;
end;

function MultiOverlayV3.vehicleSmallApp:keyMouseEvent(self, unicode, sym, modifier, isDownKey, posX, posY, isDownMouse, isUpMouse, button) --unicode, sym, modifier, isDownKey (key) -- posX, posY, isDownMouse, isUpMouse, button (mouse)
	if self:getServer() or self:get_hl("getIngameMap", {}, "getIngameMap") or self:get_hl("getFullSize", {true, true}, "getFullSize") then return;end;
	if MultiOverlayV3.vehicleSmallApp.pdaGarageOn and unicode == nil and moGeneralSettings.setMouseCursor then
		if MultiOverlayV3.vehicleSmallApp.clickAreas["garage"] ~= nil and #MultiOverlayV3.vehicleSmallApp.clickAreas["garage"] > 0 then
			for a=1, #MultiOverlayV3.vehicleSmallApp.clickAreas["garage"] do
				if MultiOverlayV3.vehicleSmallApp.clickAreas["garage"][a] ~= nil then
					if MultiOverlayV3:mouseIsInArea(posX, posY, unpack(MultiOverlayV3.vehicleSmallApp.clickAreas["garage"][a]))then
						if button == Input.MOUSE_BUTTON_LEFT and isDownMouse then
							if MultiOverlayV3.vehicleSmallApp.clickAreas["garage"][a].whatClick == "appPdaDragDrop" then
								if not self.dragDropPos.on and not g_currentMission.guiMenue.dragDrop.on then
									if not MultiOverlayV3.vehicleSmallApp.pdaGarageDragDropOn then
										MultiOverlayV3.vehicleSmallApp.pdaGarageDragDropOn = true;
										MultiOverlayV3.vehicleSmallApp.pdaGarage.viewOtherValues.dragDrop = true;
									else
										MultiOverlayV3.vehicleSmallApp.pdaGarageDragDropOn = false;
									end;
								end;
							elseif MultiOverlayV3.vehicleSmallApp.clickAreas["garage"][a].whatClick == "appPdaClose" then	
							elseif MultiOverlayV3.vehicleSmallApp.clickAreas["garage"][a].whatClick == "appPdaSave" then
							elseif MultiOverlayV3.vehicleSmallApp.clickAreas["garage"][a].whatClick == "appPdaSetting" then
							elseif MultiOverlayV3.vehicleSmallApp.clickAreas["garage"][a].whatClick == "appPdaLineLeft" then
							elseif MultiOverlayV3.vehicleSmallApp.clickAreas["garage"][a].whatClick == "appPdaLineRight" then
							elseif MultiOverlayV3.vehicleSmallApp.clickAreas["garage"][a].whatClick == "appPdaLineUp" then
							elseif MultiOverlayV3.vehicleSmallApp.clickAreas["garage"][a].whatClick == "appPdaLineDown" then
							end;
						end;
					end;
				end;
			end;
		end;
		if MultiOverlayV3.vehicleSmallApp.pdaGarageDragDropOn then
			if button == Input.MOUSE_BUTTON_LEFT and not isDownMouse then
				MultiOverlayV3.vehicleSmallApp.pdaGarageDragDropOn = false;
			end;
		end;
	end;
end;

function MultiOverlayV3.vehicleSmallApp:update(self, dt)
	if self.getServer() then return;end;
	--if not MultiOverlayV3.vehicleSmallApp.mapIsLoad and MultiOverlayV3.mapIsLoad then MultiOverlayV3.vehicleSmallApp.mapIsLoad=true;MultiOverlayV3.vehicleSmallApp:vehicleIcons(self);end;	
end;

function MultiOverlayV3.vehicleSmallApp:draw(self)	
	if self.getServer() then return;end;		
	if moSetGetOverlays.foreignIcons["vehicleSmallAppIcon"] ~= nil and #moSetGetOverlays.foreignIcons["vehicleSmallAppIcon"] > 0 then
		--moSetGetOverlays.foreignIcons["vehicleSmallAppIcon"][3]:render();
	end;
	if vehicleIconTest and MultiOverlayV3.vehicleSmallApp.pdaGarage ~= nil and #MultiOverlayV3.vehicleSmallApp.pdaGarage > 0 and MultiOverlayV3.vehicleSmallApp.vehicleStoreItems ~= nil and #MultiOverlayV3.vehicleSmallApp.vehicleStoreItems > 0 then
		--MultiOverlayV3.vehicleSmallApp.pdaGarage[5]:render();
		--posX,posY,width,height,center {setSettingsButton=0,setSaveButton=0,setCloseButton=0,setZoomButton=0,setDragDropButton=0,setUpDownButton=0,setLeftRightButton=0}; --0= Off, 1= On, 2= On is Mouse Ready
		local posX = 0.35;
		local posY = 0.7;
		if MultiOverlayV3.vehicleSmallApp.pdaGarage.viewOtherValues.posX ~= posX then posX = nil;posY=nil;end;		
		if MultiOverlayV3.vehicleSmallApp.pdaGarageDragDropOn then MultiOverlayV3.vehicleSmallApp.pdaGarage.viewOtherValues.posX = MultiOverlayV3.mouseCursor.posX;MultiOverlayV3.vehicleSmallApp.pdaGarage.viewOtherValues.posY = MultiOverlayV3.mouseCursor.posY+((MultiOverlayV3.vehicleSmallApp.pdaGarage["dragDrop"].height*14));end; --6x2+2=14 (6 Height*2,+2(up and down 1x pda edge)
		MultiOverlayV3.vehicleSmallApp.clickAreas["garage"] = moDraw.simpleAppPDA:setOpenDraw(self, "VehicleSmallApp", MultiOverlayV3.vehicleSmallApp.pdaGarage, posX, posY, 10, 6, nil, {2,2,2,0,2,2,0});
		MultiOverlayV3.vehicleSmallApp:pdaGarageDraw(self, MultiOverlayV3.vehicleSmallApp.clickAreas["garage"]);
		--moSetGetOverlays:setOverlay(self, MultiOverlayV3.vehicleSmallApp.vehicleStoreItems[1], 0.1, 0.5, moSetGetOverlays.buttonGfxWidth1*8, moSetGetOverlays.buttonGfxHeight1*8)
		--MultiOverlayV3.vehicleSmallApp.vehicleStoreItems[1]:render();
	end;
	--MultiOverlayV3.vehicleSmallApp.designIcons[1]:render();
	--respect settings for other mods please
	setTextAlignment(0);
	setTextColor(1, 1, 1, 1);
	setTextBold(false);
	--respect settings for other mods please
end;

function MultiOverlayV3.vehicleSmallApp:pdaGarageDraw(self, clickAreas)
	--if MultiOverlayV3.vehicleSmallApp.pdaGarageOn and clickAreas ~= nil and #clickAreas > 0 then
		setTextColor(1, 1, 1, 1);
		setTextBold(true);
		local optiSize = moSetGetExtras:optiHeightSize(self, MultiOverlayV3.vehicleSmallApp.pdaGarage["dragDrop"].height, "GARAGE", 0.014);
		renderText(MultiOverlayV3.vehicleSmallApp.pdaGarage["setting"].x+MultiOverlayV3.vehicleSmallApp.pdaGarage["setting"].width+0.005, MultiOverlayV3.vehicleSmallApp.pdaGarage["setting"].y+0.002, optiSize, "GARAGE");
		setTextBold(false);
		local index = 1;
		for clickArea=1, #clickAreas do
			if clickAreas[clickArea] ~= nil and clickAreas[clickArea].whatClick == "appPdaLinePos" then
				if MultiOverlayV3.vehicleSmallApp.vehicleStoreItems[index] == nil then break;end;
				local overlay = MultiOverlayV3.vehicleSmallApp.vehicleStoreItems[index].overlay;
				local difWidthHeight = 0.0055;
				local fixWidth = moSetGetOverlays.buttonGfxWidth1*5
				moSetGetOverlays:setOverlay(self, overlay, clickAreas[clickArea][1]-fixWidth, clickAreas[clickArea][3], math.abs(clickAreas[clickArea][2]-clickAreas[clickArea][1])+difWidthHeight, math.abs(clickAreas[clickArea][4]-clickAreas[clickArea][3])+difWidthHeight);
				overlay:render();
				
				--renderOverlay(overlay, clickAreas[clickArea][1], clickAreas[clickArea][3], MultiOverlayV3.vehicleSmallApp.vehicleStoreItems[index].width*4.5, MultiOverlayV3.vehicleSmallApp.vehicleStoreItems[index].height*4.5);
				local txt = tostring(MultiOverlayV3.vehicleSmallApp.vehicleStoreItems[index].hasVehicles).. "x";
				local colorName = "black"
				if MultiOverlayV3.vehicleSmallApp.vehicleStoreItems[index].isMod then txt=txt.. "Mod";end;				
				if moSetGetExtras:runsTimer("3sec", true) then
					if MultiOverlayV3.vehicleSmallApp.vehicleStoreItems[index].isWeight then txt = tostring(MultiOverlayV3.vehicleSmallApp.vehicleStoreItems[index].weight);end;
				end;
				setTextBold(true);
				setTextColor(unpack(moColors.intern[colorName]));
				renderText(overlay.x+0.003, overlay.y+overlay.height-0.016, 0.011, txt);				
				index = index+1;
				setTextColor(1, 1, 1, 1);
				setTextBold(false);
			end;
		end;
	--end;
end;
--optional--

local oldVehicleLoad = Vehicle.load;
Vehicle.load = function (self, vehicleData, asyncCallbackFunction, asyncCallbackObject, asyncCallbackArguments)
	local isOkay, result = pcall(oldVehicleLoad, self, vehicleData, asyncCallbackFunction, asyncCallbackObject, asyncCallbackArguments);
	if isOkay and self ~= nil then
		local item = g_storeManager:getItemByXMLFilename(self.configFileName);
		local typeName = Utils.getNoNil(string.lower(self.typeName), "Unknown");
		if item ~= nil then --and item.configurations ~= nil then
			local fullName = self:getFullName();
			if item.categoryName ~= nil then
				local categoryName = item.categoryName:lower();
				--print("--------")
				--print("CategoryName ".. tostring(categoryName))				
				--print("typeName= ".. tostring(typeName))
				local isJoin = true;--self.getIsEnterable ~= nil and self:getIsEnterable();
				if isJoin and (string.find(categoryName, "teleloader") or string.find(categoryName, "wheelloader") or string.find(typeName, "loadervehicle") or string.find(typeName, "telehandler")) then
					self.vsAppName = "othervehicle";
				elseif isJoin and (string.find(categoryName, "tractor") or string.find(typeName, "tractor")) then 
					if string.find(tostring(self.configFileName), "locomotive") then self.vsAppName = "train";else self.vsAppName = "tractor";end;
				elseif isJoin and (string.find(categoryName, "car") or string.find(typeName, "car")) then
					self.vsAppName = "car";
				elseif isJoin and (string.find(categoryName, "truck") or string.find(typeName, "truck")) then
					self.vsAppName = "truck";	
				elseif isJoin and (string.find(categoryName, "harvester") or string.find(categoryName, "potatovehicles") or string.find(categoryName, "beetvehicles") or string.find(typeName, "combinedrivable") or string.find(typeName, "harvester") or string.find(typeName, "combinecutterfruitpreparer")) then
					self.vsAppName = "harvester";				
				elseif string.find(categoryName, "trailer") or string.find(typeName, "trailer") or self.spec_trailer ~= nil or self.spec_waterTrailer ~= nil then
					if string.find(tostring(self.configFileName), "wagon") then 
						self.vsAppName = "wagon";
					else 
						if FillUnit.getSpecValueFillTypes(item, nil) ~= nil then
							self.vsAppName = "trailerfill"							
						else
							self.vsAppName = "trailernormal";							
						end;	
					end;
				elseif not string.find(categoryName, "weights") or self.spec_trailer ~= nil or self.spec_waterTrailer ~= nil then --is incl. pallets bigbags etc.
					if FillUnit.getSpecValueFillTypes(item, nil) ~= nil then
						self.vsAppName = "trailerfill"						
					else
						self.vsAppName = "trailernormal";						
					end;
				else 
					self.vsAppName = "unknownvehicle";
				end;
			else
				self.vsAppName = "Unknown"
			end;		
		end;
		return result;
	end;
	return false;
end;
