moAmountConfig = {};


function moAmountConfig:onStartMission()	
	moAmount:load();	
end;

function moAmountConfig:defaultValues()
	moAmount.values = {amount={}, updateTimer=10, msec=true};
end;

function moAmountConfig:loadXml(self, Xml, xmlNameTag, file, isSaveGameIndex)
	if moAmount.values == nil then moAmountConfig:defaultValues();end;
	local groupNameTag = (xmlNameTag.. ".module.amount(%d)"):format(0);
	if getXMLBool(Xml, groupNameTag.. "#mSecTimer") ~= nil then
		moAmount.values.msec = getXMLBool(Xml, groupNameTag.. "#mSecTimer");
	end;
	if getXMLInt(Xml, groupNameTag.. "#updateTimer") then
		moAmount.values.updateTimer = getXMLInt(Xml, groupNameTag.. "#updateTimer");
	end;	
end;

function moAmountConfig:saveXml(self, Xml, xmlNameTag)
	if moAmount.values == nil then moAmountConfig:defaultValues();end;
	----------------------------------------------------------------------------------------------
	local groupNameTag = (xmlNameTag.. ".module.amount(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.. "#updateTimer", moAmount.values.updateTimer);
	setXMLBool(Xml, groupNameTag.. "#mSecTimer", moAmount.values.msec);
	----------------------------------------------------------------------------------------------	
end;

function moAmountConfig.onSaveCallback()
	moSetGetClientSettings:saveConfig(self);
end;